using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using fatd_faturamento.DAL.Persistencia;
using fatd_faturamento.BLL.RegraNegocio;
using fatd_faturamento.ENTIDADE;

namespace fatd_faturamento.BLL.Repositorio
{
    public class repositorioSobreTaxa
    {

        public void Insert(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            try
            {
                dalSobreTaxa = new dalSobreTaxa();

                dalSobreTaxa.Insert(objSobreTaxa);
            }
            catch (Exception)
            {
                throw;
            }
        }

        public void Update(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            try
            {
                dalSobreTaxa = new dalSobreTaxa();

                dalSobreTaxa.Update(objSobreTaxa);
            }
            catch (Exception)
            {
                throw;
            }
        }

        public void Update_1(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            try
            {
                dalSobreTaxa = new dalSobreTaxa();

                dalSobreTaxa.Update_1(objSobreTaxa);
            }
            catch (Exception)
            {
                throw;
            }
        }

        public void Delete(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            try
            {
                dalSobreTaxa = new dalSobreTaxa();

                dalSobreTaxa.Delete(objSobreTaxa);
            }
            catch (Exception)
            {
                throw;
            }
        }

        public IList<entidadeSobreTaxa> Select(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            var lstSobreTaxa = new List<entidadeSobreTaxa>();
            DataTable dt = null;

            try
            {
                dalSobreTaxa = new dalSobreTaxa();
                dt = dalSobreTaxa.Select(objSobreTaxa);

                foreach (DataRow dr in dt.Rows)
                {
                    objSobreTaxa = new entidadeSobreTaxa();

                    if (!Convert.IsDBNull(dr["ID"]))
                        objSobreTaxa.ID = Convert.ToInt32(dr["ID"]);

                    if (!Convert.IsDBNull(dr["CONS_ID"]))
                        objSobreTaxa.CONS_ID = Convert.ToInt32(dr["CONS_ID"]);

                    if (!Convert.IsDBNull(dr["UNID_ID"]))
                        objSobreTaxa.UNID_ID = Convert.ToInt32(dr["UNID_ID"]);

                    if (!Convert.IsDBNull(dr["ZONA"]))
                        objSobreTaxa.ZONA = dr["ZONA"].ToString();

                    if (!Convert.IsDBNull(dr["LIVRO"]))
                        objSobreTaxa.LIVRO = dr["LIVRO"].ToString();

                    if (!Convert.IsDBNull(dr["CONTA"]))
                        objSobreTaxa.CONTA = dr["CONTA"].ToString();

                    if (!Convert.IsDBNull(dr["CODIGO"]))
                        objSobreTaxa.CODIGO = dr["CODIGO"].ToString();

                    if (!Convert.IsDBNull(dr["VALOR"]))
                        objSobreTaxa.VALOR = Convert.ToDouble(dr["VALOR"]);

                    if (!Convert.IsDBNull(dr["MESANO"]))
                        objSobreTaxa.MESANO = dr["MESANO"].ToString();

                    if (!Convert.IsDBNull(dr["REFERENCIA"]))
                        objSobreTaxa.REFERENCIA = dr["REFERENCIA"].ToString();

                    if (!Convert.IsDBNull(dr["FLAG"]))
                        objSobreTaxa.FLAG = dr["FLAG"].ToString();

                    lstSobreTaxa.Add(objSobreTaxa);
                }
                return lstSobreTaxa;
            }
            catch (Exception)
            {
                throw;
            }
        }

        public IList<entidadeSobreTaxa> Select_1(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            var lstSobreTaxa = new List<entidadeSobreTaxa>();
            DataTable dt = null;

            try
            {
                dalSobreTaxa = new dalSobreTaxa();
                dt = dalSobreTaxa.Select_1(objSobreTaxa);

                foreach (DataRow dr in dt.Rows)
                {
                    objSobreTaxa = new entidadeSobreTaxa();

                    if (!Convert.IsDBNull(dr["ID"]))
                        objSobreTaxa.ID = Convert.ToInt32(dr["ID"]);

                    if (!Convert.IsDBNull(dr["CONS_ID"]))
                        objSobreTaxa.CONS_ID = Convert.ToInt32(dr["CONS_ID"]);

                    if (!Convert.IsDBNull(dr["UNID_ID"]))
                        objSobreTaxa.UNID_ID = Convert.ToInt32(dr["UNID_ID"]);

                    if (!Convert.IsDBNull(dr["ZONA"]))
                        objSobreTaxa.ZONA = dr["ZONA"].ToString();

                    if (!Convert.IsDBNull(dr["LIVRO"]))
                        objSobreTaxa.LIVRO = dr["LIVRO"].ToString();

                    if (!Convert.IsDBNull(dr["CONTA"]))
                        objSobreTaxa.CONTA = dr["CONTA"].ToString();

                    if (!Convert.IsDBNull(dr["CODIGO"]))
                        objSobreTaxa.CODIGO = dr["CODIGO"].ToString();

                    if (!Convert.IsDBNull(dr["VALOR"]))
                        objSobreTaxa.VALOR = Convert.ToDouble(dr["VALOR"]);

                    if (!Convert.IsDBNull(dr["MESANO"]))
                        objSobreTaxa.MESANO = dr["MESANO"].ToString();

                    if (!Convert.IsDBNull(dr["REFERENCIA"]))
                        objSobreTaxa.REFERENCIA = dr["REFERENCIA"].ToString();

                    if (!Convert.IsDBNull(dr["FLAG"]))
                        objSobreTaxa.FLAG = dr["FLAG"].ToString();

                    lstSobreTaxa.Add(objSobreTaxa);
                }
                return lstSobreTaxa;
            }
            catch (Exception)
            {
                throw;
            }
        }

        public IList<entidadeSobreTaxa> Select_2(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            var lstSobreTaxa = new List<entidadeSobreTaxa>();

            regraNegocioGlobal regranegocioGlobal = null;

            DataTable dt = null;


            try
            {
                dalSobreTaxa = new dalSobreTaxa();

                dt = dalSobreTaxa.Select_2(objSobreTaxa);

                regranegocioGlobal = new regraNegocioGlobal();

                lstSobreTaxa = regraNegocioGlobal.ConvertDataTable<entidadeSobreTaxa>(dt);

                return lstSobreTaxa;
            }
            catch (Exception)
            {
                throw;
            }
        }

        public IList<entidadeSobreTaxa> Select_3(entidadeSobreTaxa objSobreTaxa)
        {
            dalSobreTaxa dalSobreTaxa = null;

            var lstSobreTaxa = new List<entidadeSobreTaxa>();

            regraNegocioGlobal regranegocioGlobal = null;

            DataTable dt = null;


            try
            {
                dalSobreTaxa = new dalSobreTaxa();

                dt = dalSobreTaxa.Select_3(objSobreTaxa);

                regranegocioGlobal = new regraNegocioGlobal();

                lstSobreTaxa = regraNegocioGlobal.ConvertDataTable<entidadeSobreTaxa>(dt);

                return lstSobreTaxa;
            }
            catch (Exception)
            {
                throw;
            }
        }

    }
}
